leetcode-310. Minimum Height Trees

For a undirected graph with tree characteristics, we can choose any node as the root. The result graph is then a rooted tree. Among all possible rooted trees, those with minimum height are called minimum height trees (MHTs). Given such a graph, write a function to find all the MHTs and return a list of their root labels.

Format
The graph contains n nodes which are labeled from 0 to n - 1. You will be given the number n and a list of undirected edges (each edge is a pair of labels).

You can assume that no duplicate edges will appear in edges. Since all edges are undirected, [0, 1] is the same as [1, 0] and thus will not appear together in edges.

Example 1:

Given n = 4edges = [[1, 0], [1, 2], [1, 3]]

        0
        |
        1
       / \
      2   3

return [1]

Example 2:

Given n = 6edges = [[0, 3], [1, 3], [2, 3], [4, 3], [5, 4]]

     0  1  2
      \ | /
        3
        |
        4
        |
        5

return [3, 4]

Hint:

  1. How many MHTs can a graph have at most?

Note:

(1) According to the definition of tree on Wikipedia: “a tree is an undirected graph in which any two vertices are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.”

(2) The height of a rooted tree is the number of edges on the longest downward path between the root and a leaf.

題意解析:

題目大概就是告訴你有一個無向圖。你可以選取其中一個節點作爲根節點來生成樹。現在要求生成的樹的高度最小,給出最小高度樹的根節點。

看到這道題,首先想到的應該是遍歷每個節點,看看誰當根高度最小。當然這是不可能的,因爲複雜度想想就很高,所以我們反過來,從葉子入手。每次去掉一圈葉子節點,最後剩下的當根就是高度最小樹。這個答案不是1個就是2個,可以試着畫圖看看,代碼如下:

public class Solution {
    public List<Integer> findMinHeightTrees(int n, int[][] edges) {
        List<Integer> leaves = new LinkedList();
        if(n == 0){
            return leaves;
        }
        if(n == 1){
            leaves.add(0);
            return leaves;
        }
        HashSet<Integer>[] graph = new HashSet[n];
        for(int i = 0; i < n; i++){
            graph[i] = new HashSet();
        }
        
        for(int x[] : edges){
            graph[x[0]].add(x[1]);
            graph[x[1]].add(x[0]);
        }
        
        for(int i = 0; i < n; i++){
            if(graph[i].size() == 1){
                leaves.add(i);
            }
        }
        
        while(n > 2){
            List<Integer> newLeaves = new LinkedList();
            for(int x : leaves){
                for(int y : graph[x]){
                    graph[x].remove(y);
                    graph[y].remove(x);
                    n--;
                    if(graph[y].size() == 1){
                        newLeaves.add(y);
                    }
                }
            }
            leaves = newLeaves;
        }
        return leaves;
    }
}

這裏要注意一下。使用LinkedList比ArrayList快,因爲LinkedList插入快讀取慢,而ArrayList正好相反,這道題更適合使用LinkedList

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章